#ifndef CONSTS_H_
#define CONSTS_H_

#include <string>

#include <boost/multi_array.hpp>

typedef boost::multi_array<int, 2> mul_arr_int_2;
typedef boost::multi_array<int, 3> mul_arr_int_3;
typedef boost::multi_array<double, 2> mul_arr_dbl_2;
typedef boost::multi_array<double, 3> mul_arr_dbl_3;
typedef boost::multi_array_types::index_range mul_arr_range;

struct lh_para_dir_mix_para { int dim; int num_dir_mix; int num_pos; mul_arr_int_2 n; };

using namespace std;



class Consts
{
private:
	static const unsigned NUM_NUCL = 4;
	static const unsigned NUM_TR_FREQS = 4;
	static const unsigned NUM_TR_PROBS = 7;
	static const unsigned MAX_NUM_DISTR = 6;

	static vector<double> m_alpha;
	static vector<double> m_rho;

	static string m_stamp;
	static bool m_use_scratch;
public:
	static string& stamp() { return m_stamp; }
	static bool& use_scratch() { return m_use_scratch; }
	static unsigned num_nucl() { return NUM_NUCL; }
	static unsigned num_tr_freqs() { return NUM_TR_FREQS; }
	static unsigned num_tr_probs() { return NUM_TR_PROBS; }
	static unsigned max_num_distr() { return MAX_NUM_DISTR; }
	static vector<double> alpha() { return m_alpha; }
	static double sum_alpha();
	static vector<double> rho() { return m_rho; }
};

#endif
