#ifndef DIRICHLET_H_
#define DIRICHLET_H_

#include "consts.h"

#include <vector>

#include <gsl/gsl_vector_double.h>
#include <arprec/mp_real.h>

using namespace std;


double log_prob_p_given_alpha(vector<double> p, vector<double> alpha);
void est_para_dir_mix(const mul_arr_int_2 freq, const int dim, const int num_dir_mix, const int num_pos, mul_arr_dbl_2* alpha, vector<double>* q);
mp_real prob_n_given_dir_mix(const int dim, const int num_dir_mix, const vector<int> n,
						   	 const mul_arr_dbl_2 alpha, const vector<double> q);
void est_prob_from_dir_mix(const int dim, const int num_dir_mix, const vector<int> n,
						   const mul_arr_dbl_2 alpha, const vector<double> q, vector<double>* p);
pair<double, double> inv_ln_gamma(double x);

#endif 
