#include "io_contnr.h"

#include "boost/format.hpp"
#include "boost/multi_array.hpp"
#include <gsl/gsl_math.h>

using namespace std;
using namespace boost;



// TODO: unite operators

ostream& operator<<(ostream& s, const multi_array<int, 2>& a)
{
	s << "  ";
	for (unsigned i = a.index_bases()[1]; i < a.shape()[1] + a.index_bases()[1]; ++i)
		s << format("%5d") % i;
	s << endl;

	for (unsigned i = a.index_bases()[0]; i < a.shape()[0] + a.index_bases()[0]; ++i) {
		s << format("%2d") % i;
		for (unsigned j = a.index_bases()[1]; j < a.shape()[1] + a.index_bases()[1]; ++j)
			s << format("%5d") % a[i][j];
		s << endl;
	}
	return s;
}



ostream& operator<<(ostream& s, const multi_array<double, 2>& a)
{
	const double FORMAT_BOUNDARY = 1e-3;   // if any number in the array is smaller than this constant, use scientific number format, otherwise ordinary
	double min = numeric_limits<double>::max();
	for (unsigned i = a.index_bases()[0]; i < a.shape()[0] + a.index_bases()[0]; ++i)
		for (unsigned j = a.index_bases()[1]; j < a.shape()[1] + a.index_bases()[1]; ++j)
			min = GSL_MIN(min, abs(a[i][j]));
	string cell_format = (min < FORMAT_BOUNDARY) ? "% 1.4e" : "% 1.4e";

	s << "  ";
	for (unsigned i = a.index_bases()[1]; i < a.shape()[1] + a.index_bases()[1]; ++i)
		s << format("% 13d") % i;
	s << endl;

	for (unsigned i = a.index_bases()[0]; i < a.shape()[0] + a.index_bases()[0]; ++i) {
		s << format("%2d") % i;
		for (unsigned j = a.index_bases()[1]; j < a.shape()[1] + a.index_bases()[1]; ++j)
			s << "  " << format(cell_format) % a[i][j];
		s << endl;
	}
	return s;
}



ostream& operator<<(ostream& s, const multi_array<int, 3>& a)
{
	for (unsigned i = a.index_bases()[0]; i < a.shape()[0] + a.index_bases()[0]; ++i) {
		s << "(" << i << ")" << endl;
		s << "  ";
		for (unsigned k = a.index_bases()[2]; k < a.shape()[2] + a.index_bases()[2]; ++k)
			s << format("%5d") % k;
		s << endl;

		for (unsigned j = a.index_bases()[1]; j < a.shape()[1] + a.index_bases()[1]; ++j) {
			s << format("%2d") % j;
			for (unsigned k = a.index_bases()[2]; k < a.shape()[2] + a.index_bases()[2]; ++k)
				s << format("%5d") % a[i][j][k];
			s << endl;
		}
		s << endl;
	}
	return s;
}



ostream& operator<<(ostream& s, const multi_array<double, 3>& a)
{
	const double FORMAT_BOUNDARY = 1e-3;   // if any number in the array is smaller than this constant, use scientific number format, otherwise ordinary
	double min = numeric_limits<double>::max();
	for (unsigned i = a.index_bases()[0]; i < a.shape()[0] + a.index_bases()[0]; ++i)
		for (unsigned j = a.index_bases()[1]; j < a.shape()[1] + a.index_bases()[1]; ++j)
			for (unsigned k = a.index_bases()[2]; k < a.shape()[2] + a.index_bases()[2]; ++k)
				min = GSL_MIN(min, abs(a[i][j][k]));
	string cell_format = (min < FORMAT_BOUNDARY) ? "% 1.4e" : "% 1.4e";

	for (unsigned i = a.index_bases()[0]; i < a.shape()[0] + a.index_bases()[0]; ++i) {
		s << "(" << i << ")" << endl;
		s << "  ";
		for (unsigned k = a.index_bases()[2]; k < a.shape()[2] + a.index_bases()[2]; ++k)
			s << format("% 13d") % k;
		s << endl;

		for (unsigned j = a.index_bases()[1]; j < a.shape()[1] + a.index_bases()[1]; ++j) {
			s << format("%2d") % j;
			for (unsigned k = a.index_bases()[2]; k < a.shape()[2] + a.index_bases()[2]; ++k)
				s << "  " << format(cell_format) % a[i][j][k];
			s << endl;
		}
		s << endl;
	}
	return s;
}




