% the parameters for the LDA version of jpHMM
classdef MachLearnPara < SubSizePara
    properties
        lambda
        gamma_div_lambda
        res_per_sector
    end
    properties (Dependent)
        gamma
    end
    
    methods
        function obj = MachLearnPara(small_subs, large_subs, jp, lambda, gamma_div_lambda, res_per_sector)
            obj@SubSizePara(jp, small_subs, large_subs);
            obj.lambda = lambda;
            obj.gamma_div_lambda = gamma_div_lambda;
            obj.res_per_sector = res_per_sector;
        end
        
        function gamma = get.gamma(obj)
            gamma = obj.gamma_div_lambda * obj.lambda;
        end
        
        function str = char(obj)
            str = (['jp: ' num2str(obj.jp) char(13)]);
            str = ([str  'lambda: ' num2str(obj.lambda) char(13)]);
            str = ([str 'gamma/lambda: ' num2str(obj.gamma_div_lambda) char(13)]);
            str = ([str 'residuals per sector: ' num2str(obj.res_per_sector) char(13)]);
        end     

        function ret = copy(obj)
            ret = MachLearnPara(obj.small_subs, obj.large_subs, obj.jp, obj.lambda, obj.gamma_div_lambda, obj.res_per_sector);
        end
    end
end