package MySQL;

import java.net.*;
import java.sql.*;
import java.util.Map;
import static java.lang.System.out;
 
public class MySQLConnection {

// Connection object
private Connection con = null;
// Statement object
private Statement stmt = null;

// Constructor
public MySQLConnection(String server, String database, String user, String passwd) {
	try {		
		/* Loading the driver */
		Class.forName("com.mysql.jdbc.Driver").newInstance();
		/* Getting Connection */
		String conStr = "jdbc:mysql://" + server + "/" + database;
		con = DriverManager.getConnection(conStr, user, passwd);
		stmt = con.createStatement();
	}
	catch (Exception e) {
		e.printStackTrace();
	}
}

// Destructor
protected void finalize() {
	try {
		/* Closing the Connection */
		stmt.close();
		con.close();
	}
	catch (Exception e) {
		e.printStackTrace();
	}	
}

public ResultSet executeSQLQuery(String query) {
	ResultSet rs = null;
	try {
		rs = stmt.executeQuery(query);	
	} 
	catch (Exception e) {
		e.printStackTrace();
	}
	return rs;
}

public void executeSQLStatement(String query) {
	try {
		stmt.execute(query);	
	} 
	catch (Exception e) {
		e.printStackTrace();
	}

}

}



