% generates a stamp of identifying files
function stamp = Stamp()
    id_filename = FilesDirs.id_filename;
    fid = fopen(id_filename);
    if fid == -1 
        error(['Unable to open: ' id_filename]) 
    end
    
    % get id
    tline = fgetl(fid);
    if tline == -1
        error 'File format error in id file'
    end
    id = str2num(tline);
    fclose(fid);
    
    % save incremented id
    fid = fopen(id_filename, 'w');
    fprintf(fid, '%d\n', id + 1);    
    fclose(fid);
    
    % generate stamp
    stamp = [datestr(now, 'yyyy-mm-dd_HH-MM-SS') '_' num2str(id)];
end